<!--产品分类 -->
<template>
    <page-container>
        <!-- <pro-search
            :columns="query.columns"
            target="category"
            @search="handleSearch"
                                /> -->
        <j-search :columns="searchs" @search="handleSearch" :type="value" />
        <FullPage class="monitor-page">
            <div class="left-tree">
                <h3 >监控区域</h3>
                <j-tree
                    v-model:expandedKeys="expandedKeys"
                    v-model:selectedKeys="selectedKeys"
                    :tree-data="treeDataList"
                    :fieldNames="{ title: 'name', key: 'id',children:'children' }"
                    @select='treeSelect'
                    
                >
                    <!-- <template #title="{ title, key }">
                        <span
                            v-if="key === selectedKeys[0]"
                            style="color: #1890ff"
                            >{{ title }}</span
                        >
                        <template v-else>{{ title }}</template>
                    </template> -->
                </j-tree>
            </div>

            <JProTable ref="tableRef" :columns="table.columns" :request="queryMDInfo" model="TABLE"
                v-model:expandedRowKeys="expandedRowKeys" :scroll="{ y: 550 }" :defaultParams="{
                    paging: false,
                    sorts: [
                        { name: 'sortIndex', order: 'asc' },
                        {
                            name: 'createTime',
                            order: 'desc',
                        },
                    ],
                }" :params="params" :loading="tableLoading">
                <template #headerTitle>
                    <j-space>
                        <PermissionButton type="primary" @click="add" hasPermission="device/Category:add">
                            <template #icon>
                                <AIcon type="PlusOutlined" />
                            </template>
                            新增监控设备
                        </PermissionButton>
                        <!-- <PermissionButton danger @click="onDelete" hasPermission="device/Category:delete">
                            <template #icon>
                                <AIcon type="DeleteOutlined" />
                            </template>
                            删除
                        </PermissionButton> -->
                    </j-space>
                </template>
                 <template #createTime="slotProps">
                        <span>{{
                            dayjs(slotProps.createTime).format(
                                'YYYY-MM-DD HH:mm:ss',
                            )
                        }}</span>
                </template>

                <template #action="slotProps">
                    <j-space>
                        <template v-for="(i, index) in getActions(slotProps, 'table')" :key="i.key">
                            <PermissionButton :disabled="i.disabled" :popConfirm="i.popConfirm"
                                :hasPermission="'device/Category:' + i.key" :tooltip="{
                                    ...i.tooltip,
                                }" @click="i.onClick" type="link" style="padding: 0px" :danger="i.key === 'delete'">
                                <template #icon>
                                    <AIcon :type="i.icon" />
                                </template>
                            </PermissionButton>
                            <!-- <j-divider v-if="actionLength - 1 != index" type="vertical" /> -->
                        </template>
                    </j-space>
                </template>
            </JProTable>
        </FullPage>
        <!-- 新增和编辑弹窗 -->
        <ModifyDrawer ref="modifyRef" :formData="currentForm" :title="title" :isAdd="isAdd" :isChild="isChild"
            @refresh="refresh" />
        <j-modal :visible="visible" title="确认删除" @ok="handleOk" @cancel="handleCancel" :confirmLoading="confirmLoading">
            <p class="delete_content"><img :src="getImage('/question-mark.png')" alt=""></p>
            <p class="delete_content title">确认删除这条信息吗？</p>
            <p class="delete_content desc">删除后无法恢复，确定要删除吗？</p>
        </j-modal>
    </page-container>
</template>
<script lang="ts" name="Category" setup>
import { getImage } from '@/utils/comm';
import { queryMD,queryMDInfo, deleteMD } from '@/api/monitoring/device';
import { findArea } from '@/api/monitoring/area';
import type { ActionsType } from '@/components/Table/index';
import ModifyDrawer from './components/modifyDrawer/index.vue';
import { message } from 'jetlinks-ui-components';
import dayjs from 'dayjs';

import type { TreeProps } from 'ant-design-vue';
const treeData: TreeProps['treeData'] = [
    {
        title: 'A座',
        key: '0-0',
        children: [
            {
                title: '库房302',
                key: '0-0-0',
                children: [
                    { title: '摄像头1', key: '0-0-0-0' },
                    { title: '摄像头1', key: '0-0-0-1' },
                ],
            },
            {
                title: '库房303',
                key: '0-0-1',
                children: [{ key: '0-0-1-0', title: '摄像头1' }],
            },
        ],
    },
];
const expandedKeys = ref<string[]>([]);
const selectedKeys = ref<string[]>([]);
const videoType = ref<number>(2);
const videoList = ref<any>([]);

watch(expandedKeys, () => {
    console.log('expandedKeys', expandedKeys);
});
watch(selectedKeys, () => {
    console.log('selectedKeys', selectedKeys);
});

const expandedRowKeys = ref<any>([]);
const tableRef = ref<Record<string, any>>({});
const modifyRef = ref();
const dataSource = ref<any>([]);
const currentForm = ref<any>({});
const title = ref('');
const isAdd = ref(0);
const isChild = ref(0);
const tableLoading = ref(false);
let params = ref();
let actionLength = ref<number>(0);

const visible = ref<boolean>(false);
const confirmLoading = ref<boolean>(false);
const value = ref('object');
const searchs = ref<any>([
    {
        title: '',
        dataIndex: 'name',
        search: {
            type: 'string',
            componentProps: {
                placeholder: '请输入关键字',
            },
            defaultValue: '123123',
        },
    }
]);

const treeSelect = (v: any, option: any) => {
  const node = option.node
  params.value = { where: "areaId="+node.id };  
}


const treeDataList = ref<any>([]);

onMounted(() => {
   findArea().then(res=>{
     console.log("=========findArea========",res.result)
     treeDataList.value = res.result;
   })
});

// const onSearch = (e: any) => {
//     console.log(e)
// };

const onDelete = () => {
    visible.value = true;
}
/**
 * 删除确认
 * @param e 
 */
const handleOk = (e: MouseEvent) => {
    console.log(e);
    confirmLoading.value = true;

    setTimeout(() => {
        confirmLoading.value = false;

        visible.value = false;
    }, 1000);
};
/**
 * 删除取消
 * @param e 
 */
const handleCancel = (e: MouseEvent) => {
    console.log(e);
    visible.value = false;
};

/**
 * 搜索
 */
const handleSearch = (e: any) => {
    let arr = [];
    for (let key in e) {
        arr.push(key + "=" + e[key]);
    }

    params.value = { where: arr.join(" and ") };
    expandedRowKeys.value = [];
};
/**
 * 操作栏按钮
 */
const getActions = (
    data: Partial<Record<string, any>>,
    type: 'table',
): ActionsType[] => {
    if (!data) return [];
    const actions = [
        // {
        //     key: 'view',
        //     text: '详情',
        //     tooltip: {
        //         title: '详情',
        //     },
        //     icon: 'UnorderedListOutlined',
        //     onClick: async () => {
        //         title.value = '密集柜详情';
        //         isAdd.value = 2;
        //         currentForm.value = data;
        //         nextTick(() => {
        //             // modifyRef.value.show(data);
        //         });
        //     },
        // },
        {
            key: 'update',
            text: '编辑',
            tooltip: {
                title: '编辑',
            },
            icon: 'EditOutlined',
            onClick: async () => {
                title.value = '编辑监控设备信息';
                isAdd.value = 2;
                currentForm.value = data;
                nextTick(() => {
                    modifyRef.value.show(data);
                });
            },
        },
        {
            key: 'delete',
            text: '删除',
            tooltip: {
                title: '删除',
            },
            icon: 'DeleteOutlined',
            popConfirm: {
                title: '确认删除?',
                okText: ' 确定',
                cancelText: '取消',
                onConfirm: async () => {
                    const resp = await deleteMD(data.id);
                    if (resp.status === 200) {
                        message.success('操作成功！');
                        tableRef.value.reload();
                    } else {
                        message.error('操作失败！');
                    }
                },
            },
        },
    ];
    actionLength.value = actions.length;

    return actions;
};

const table = reactive({
    columns: [
        {
            title: '编码',
            dataIndex: 'code',
            key: 'code',
        },
        {
            title: '名称',
            dataIndex: 'name',
            key: 'name',
        },        
        {
            title: '设备类别',
            dataIndex: 'deviceType',
            key: 'deviceType',
        },
        {
            title: '访问地址',
            dataIndex: 'serverAddr',
            key: 'serverAddr',
        },
        {
            title: '设备型号',
            dataIndex: 'model',
            key: 'model',
        },
        {
            title: '品牌',
            dataIndex: 'brand',
            key: 'brand',
        },
        {
            title: '设备序号',
            dataIndex: 'deviceSn',
            key: 'deviceSn',
        },
        {
            title: '所属库房',
            dataIndex: 'warehouse.name',
            key: 'warehouse.name',
        },
        {
            title: '所属区域',
            dataIndex: 'area.name',
            key: 'area.name',
        },
        {
            title: '创建日期',
            dataIndex: 'createTime',
            key: 'createTime',
            scopedSlots: true
        },
        {
            title: '操作',
            key: 'action',
            fixed: 'right',
            ellipsis: true,
            scopedSlots: true,
            // width: 125,
        },
    ],
    /**
     * 添加产品分类
     */
    add: async () => {
        title.value = '新增监控设备信息';
        isAdd.value = 0;
        isChild.value = 3;
        console.log("========selectedKeys====val===",selectedKeys.value[0]);
        currentForm.value ={areaId:selectedKeys.value[0]}
        
        nextTick(() => {
            modifyRef.value.show(currentForm.value);
        });
    },
    /**
     * 刷新表格数据
     */
    refresh: () => {
        tableRef.value.reload();
    },
});
const { add, columns, refresh } = toRefs(table);
/**
 * 初始化
 */
</script>
<style scoped lang="less">
:deep(._jtable-body_1eyxz_1 ._jtable-pagination_1eyxz_43) {
    margin-top: 20px;
    display: none;
    justify-content: flex-end;
}

.monitor-page {
    display: flex;
    align-items: flex-start;
    justify-content: space-between;
    width: 100%;
    height: 100%;
    .left-tree {
        width: 200px;
        height: 100%;
        padding: 16px;
        border-right: 1px solid #ececec;
    }
}

.delete_content {
    text-align: center;

    &.title {
        font-size: 18px;
        font-family: PingFang SC-Medium, PingFang SC;
        font-weight: 500;
        color: #333333;
        line-height: 16px;
    }

    &.desc {
        font-size: 14px;
        font-family: PingFang SC-Regular, PingFang SC;
        font-weight: 400;
        color: #4F4F4F;
        line-height: 22px;
    }

    img {
        width: 40px;
        height: 40px;
    }
}
</style>
